# .gitlab-ci.yml

# Include the Secret Detection template
include:
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml


# These are the stages for each of the jobs in our pipeline.
stages:
  - test
  - Integration
  #- Dry Run
  #- Deploy
  #- Destroy

before_script:
  - eval $(ssh-agent -s)
  - cat ${TF_VAR_provisioner_path} | tr -d '\r' | ssh-add -
  - mkdir -p ~/.ssh
  - chmod 700 ~/.ssh
  - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
  - chmod 644 ~/.ssh/known_hosts
  - git config --global user.email "${GITLAB_USER_LOGIN}@gitlab.com"
  - git config --global user.name "Darth Vader"
  - export TF_VAR_gl_user=${GITLAB_USER_LOGIN}
  - export TF_VAR_gl_project_title=$(echo "$CI_PROJECT_TITLE" | awk '{print tolower($0)}')
  - echo $CI_COMMIT_BRANCH
  - echo CI_COMMIT_REF_NAME
  - git clone git@gitlab.com:gitlab-com/sandbox-cloud/project-templates/support-interview-resources-template.git
  - rm -f support-interview-resources-template/main.tf
  - cp test/replace_main.tpl support-interview-resources-template/main.tf
  - sed -i "s/support-interview-resource-module.git/support-interview-resource-module.git?ref=${CI_COMMIT_BRANCH}/" support-interview-resources-template/main.tf
  #- cat support-interview-resources-template/main.tf

# This is used by `extends: .terraform` in each of the Terraform stage jobs.
# We do not define these as global values so that they do not interfere with
# other unrelated Terraform jobs that may be added to `.gitlab-ci.yml`, such
# as code quality or Auto DevOps jobs.
# NOTE: It is recommended to use a tagged version number for the image if your
# Terraform configuration uses syntax from v0.13 and earlier.
.terraform:
  image:
    name: hashicorp/terraform:latest
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'


##### Checks ##### 

#
# Terraform format
#

check:terraform-fmt:
  stage: test
  image:
    name: "hashicorp/terraform"
    entrypoint: [ "" ]
  before_script:
    - terraform version
  script:
    - terraform fmt -check -recursive -diff .
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags

#
# Terraform Lint
#

check:tflint:
  stage: test
  image:
    name: ghcr.io/terraform-linters/tflint:latest
    entrypoint: [""]
  before_script: []
  script:
    - find * -type d -print0 | xargs -0 -n1 -I % sh -c "printf '\n%\n' && tflint -c .tflint.hcl %"
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags

#
# Markdown Lint
#

check:markdownlint:
  stage: test
  image:
    name: node:lts-alpine3.14
    entrypoint: [ "" ]
  before_script: []
  script:
    - npm add -g markdownlint markdownlint-cli
    - markdownlint *.md
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags

#
# Markdown Link Check
#

check:markdown-link-check:
  stage: test
  image:
    name: ghcr.io/tcort/markdown-link-check
    entrypoint: [""]
  before_script: []
  script:
    - find *.md -print0 | xargs -0 -n1 /src/markdown-link-check
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags


#
# Secret Detection
#

secret_detection:
   before_script: []
   rules:
    - if: '$CI_BUILD_REF_NAME == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE == "push" || $CI_PIPELINE_SOURCE == "merge_request_event"'

#
# Dependency Scanning
#

bundler-audit-dependency_scanning:
  before_script: []
  rules:
    - if: '$CI_BUILD_REF_NAME == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE == "push" || $CI_PIPELINE_SOURCE == "merge_request_event"'


#
# Deploy Stage Jobs
#

# ✨ Integrate:
#   stage: Integration
#   image:
#     name: curlimages/curl:7.81.0
#     entrypoint: [ "" ]
#   before_script: []
#   script:
#     - curl -X POST --fail -F token=$CI_JOB_TOKEN -F ref=container-registry-gitlab-omnibus-module https://gitlab.com/api/v4/projects/32698548/trigger/pipeline
#   #needs: []
#   rules:
#     - if: '$CI_COMMIT_BRANCH == "main"'
  # only:
  #   - main  



